//--------------------------------------------------------------------
// TSI.mq4 
//       
//--------------------------------------------------------------------

#property indicator_separate_window         // indicator_chart_window, indicator_separate_window
#property indicator_buffers     3           //  
#property indicator_color1      Red         //    Red Blue Lime 
#property indicator_color2      Blue        //   
#property indicator_color3      Yellow
#property indicator_level1      -20
#property indicator_level2       20
//#property indicator_minimum   -100
//#property indicator_maximum    100
 
extern int LengthMtm            = 21;
extern int LengthSmooth         = 5;
extern int LengthErgodic        = 5;
extern int HistoryLimit         = 2000;

double tsi[], ergodic[], cross[];           //   (  )
double mtm[], base[], mtmMA[], mtmS[];


//-----------------------------------------------------------------------------
int MathSgn(double Value = 0.0)
{
    if (Value < 0) return(-1); else return( 1);
}

//-----------------------------------------------------------------------------
int init()                         
{
    IndicatorBuffers(7);
    SetIndexBuffer(0, tsi);                                 //   
    SetIndexBuffer(1, ergodic);                             //   
    SetIndexBuffer(2, cross);                               //   
    
    SetIndexBuffer(3, mtm);
    SetIndexBuffer(4, base);
    SetIndexBuffer(5, mtmMA);
    SetIndexBuffer(6, mtmS);
        
    SetIndexStyle (0, DRAW_LINE,        STYLE_SOLID, 1);    //   DRAW_HISTOGRAM STYLE_SOLID
    SetIndexStyle (1, DRAW_LINE,        STYLE_SOLID, 1);    //          
    SetIndexStyle (2, DRAW_ARROW,       STYLE_SOLID, 0);    //  
    SetIndexArrow (2, 161);
    
    SetIndexLabel(0, "TSI");
    SetIndexLabel(1, "Ergodic");
    SetIndexLabel(2, "Cross");


    IndicatorShortName("TSI("+LengthMtm+","+LengthSmooth+","+LengthErgodic+")");    
    
    return(0);                                      
}

//-----------------------------------------------------------------------------
int start()                         
{    
    if (HistoryLimit == 0) HistoryLimit = Bars;
    
    int Counted_bars            = IndicatorCounted();
    int i, limit                = MathMin(Bars - Counted_bars - 1, HistoryLimit); 
    double tmp;
    for (i=limit;i>=0;i--) {
        mtm[i]                  = Close[i] - Close[i+1];
        base[i]                 = High[i]  - Low[i];
   }
    for (i=limit;i>=0;i--) {
        mtmMA[i]                = iMAOnArray(mtm,   0, LengthMtm,     0, MODE_EMA, i) * 100;
        tmp                     = iMAOnArray(base,  0, LengthMtm,     0, MODE_EMA, i);
        mtmS[i]=0;
        if (tmp>0)  mtmMA[i]   /= tmp;
        mtmS[i]                 = iMAOnArray(mtmMA, 0, LengthSmooth,  0, MODE_EMA, i);
        tsi[i]                  = mtmS[i];
   }
   for (i=limit;i>=0;i--) {
        ergodic[i]              = iMAOnArray(mtmS,  0, LengthErgodic, 0, MODE_EMA, i); 
        
         cross[i]           = EMPTY_VALUE;
        if ( MathSgn(tsi[i+1] - ergodic[i+1]) != MathSgn(tsi[i] - ergodic[i]) )       
            cross[i]           = ergodic[i];


        
    }
    
    return(0);                          
}